# Earth Mover's Distance Dynamic Filtering

MATLAB implementation of the EMD-DF algorithm ([paper](https://doi.org/10.1109/LSP.2020.3001760)).

## Paper abstract
Tracking algorithms such as the Kalman filter aim to improve inference performance by leveraging the temporal dynamics in streaming observations. However, the tracking regularizers are often based on the lp-norm which cannot account for important geometrical relationships between neighboring signal elements. We propose a practical approach to using the earth mover's distance (EMD) via the earth mover's distance dynamic filtering (EMD-DF) algorithm for causally tracking time-varying sparse signals when there is a natural geometry to the coefficient space that should be respected (e.g., meaningful ordering). Specifically, this paper presents a new Beckmann formulation that dramatically reduces computational complexity, as well as an evaluation of the performance and complexity of the proposed approach in imaging and frequency tracking applications with real and simulated neurophysiology data.

## Requirements
- [MATLAB](https://www.mathworks.com/products/matlab.html)
- [CVX](http://cvxr.com/cvx/)

## Getting started
- Download and install the [CVX](http://cvxr.com/cvx/) optimization package for MATLAB
- Clone the code in this repository:
`git clone  https://github.com/siplab-gt/emd-df.git`
- Run `demo.m` in MATLAB which should produce the following:
![Demo output](figure.png)
